
;This code is based on Nehe OpenGL tutorial
; Not Completed
TGA			struct
Datas			dword	?
_Width			dword	?
Height			dword	?
Bits			dword	?
Orig_Width		dword	?
Orig_Height		dword	?
TGA			ends

TGAHeader struct
	header byte [12] 0
TGAHeader ends

TGAInfo struct
	 header					byte [6] 0
	 bytesPerPixel			dword 0
	 imageSize				dword 0
	 _type					dword 0
	 Height					dword 0
	 _Width					dword 0
	 Bpp					dword 0
TGAInfo ends

fTGA struct
	_width 		dword 0
	height 		dword 0
	_type 		dword 0
	bpp			dword 0
	ImageSize 	dword 0
	ImageData	dword 0
fTGA ends

.data
	uTGA byte 0,0,2,0,0,0,0,0,0,0,0,0
	cTGA byte 0,0,10,0,0,0,0,0,0,0,0,0 
	;hdr byte 0 dup(12)
.code

LoadCompressedTGA proc uses esi edi lpFile:dword,lpTGA:dword
	LOCAL buff[256]:dword
	
	mov esi,lpFile
	mov edi,lpTGA
	
	xor ecx,ecx
	mov cx,[esi+12]
	push ecx
	pop [edi].fTGA._width

	xor ecx,ecx
	mov cx,[esi+14]
	push ecx
	pop [edi].fTGA.height
	
	xor ecx,ecx
	mov cx,[esi+16]
	push ecx
	pop [edi].fTGA.bpp
	
	.if [edi].fTGA._width==0
		invoke MessageBox,0,CADD("Error: Pixel width is not valid"),0,0
		xor eax,eax
		dec eax
		ret
	.endif

	.if [edi].fTGA.height==0
		invoke MessageBox,0,CADD("Error: Pixel height is not valid"),0,0
		xor eax,eax
		dec eax
		ret
	.endif
	
	.if [edi].fTGA.bpp!=24
		.if [edi].fTGA.bpp!=32
			invoke MessageBox,0,CADD("Error: Pixel Depth is not Valid"),0,0
			xor eax,eax
			dec eax
			ret
		.else
			push GL_RGBA
			pop [edi].fTGA._type
		.endif
	.else
		push GL_RGB
		pop [edi].fTGA._type		
	.endif
	
	push [edi].fTGA.bpp
	pop eax
	xor edx,edx
	mov ecx,8
	div ecx
	
	xor edx,edx
	mov ecx,[edi].fTGA._width
	mul ecx
	mov ecx,[edi].fTGA.height
	mul ecx
	
	push eax
	pop [edi].fTGA.ImageSize
	
	invoke mAlloc,eax
	push eax
	pop [edi].fTGA.ImageData
	
	
	
	
	ret
LoadCompressedTGA endp


fReadTGA proc uses esi edi lpFileName:dword, lpTGA:dword
	LOCAL mem,ln:dword
	
	invoke exist,lpFileName
	.if eax!=1
		invoke MessageBox,0,CADD("File not found"),0,0
		ret
	.endif
	
	invoke filesize,lpFileName
	mov ln,eax
	invoke mAlloc,eax
	mov mem,eax
	
	invoke read_disk_file,lpFileName,addr mem,addr ln
	
	mov ecx,mem
	lea edx,uTGA
	
	invoke cmpmem,edx,ecx,12
	.if eax!=0
		
	.endif
	
	mov ecx,mem
	lea edx,cTGA
	
	invoke cmpmem,edx,ecx,12
	.if eax!=0
		invoke LoadCompressedTGA,mem,lpTGA
	.endif
	
	error:
	invoke GlobalFree,mem
	
	ret
fReadTGA endp



; Created By Hitchkr from www.masmforum.com

Load_File		proc	FName:dword, Read_Bytes:dword
			local	FHandle:dword
			local	FSize:dword
			local	FPosition:dword

			mov	FPosition, 0
			invoke	CreateFile, FName, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, 0
			inc	eax
			je	Error_LoadFile
			dec	eax
			mov	FHandle, eax
			invoke	GetFileSize, eax, 0
			inc	eax
			je	Error_LoadFile
			dec	eax
			mov	FSize, eax
			inc	eax				; Append a 0 char
			mov	eax, ALLOCMEM(eax)
			test	eax, eax
			jz	Error_LoadFile
			mov	FPosition, eax
			invoke	ReadFile, FHandle, FPosition, FSize, Read_Bytes, 0
			.if	eax == 0
				FREEMEM	FPosition
				mov	FPosition, 0
			.endif
			invoke	CloseHandle, FHandle
Error_LoadFile:		mov	eax,FPosition			; Return the memory block address or 0
			ret
Load_File		endp

; ------------------------------------------------------
; Name: Load_TGA
; Desc: Load a 24 or 32 bits TARGA file into memory
Load_TGA		proc	uses ebx esi edi TGA_FName:dword, TGA_Struct:dword, Color_Key:dword
			local	TGA_Buffer:dword
			local	FSize:dword

			mov	esi, TGA_Struct
			mov	[esi + TGA.Datas], NULL

			; Load texture into memory
			invoke	Load_File, TGA_FName, addr FSize
			test	eax, eax
			jz	Err_TGA_Load
			mov	TGA_Buffer, eax

			; Decode the TGA file
			mov	ebx, eax
			cmp	byte ptr [ebx + 1], 1			; Can't have a colormap
			je	Err_TGA_Format
			cmp	byte ptr [ebx + 2], 2			; Must be uncompressed, true color
			jne	Err_TGA_Format
			movzx	eax, word ptr [ebx + 12]
			test	eax, eax
			js	Err_TGA_Format
			jz	Err_TGA_Format
			mov	[esi + TGA._Width], eax
			movzx	eax, word ptr [ebx + 14]
			test	eax, eax
			js	Err_TGA_Format
			jz	Err_TGA_Format
			mov	[esi + TGA.Height], eax
			movzx	eax, byte ptr [ebx + 16]
			mov	[esi + TGA.Bits], eax
			cmp	eax, 24					; Must be 24 bits (bottom left)
			je	GoodTextureFormat
			cmp	eax, 32					; or 32 bits
			je	GoodTextureFormat
Err_TGA_Format:		FREEMEM	TGA_Buffer
Err_TGA_Load:		xor	eax, eax				; Not loaded
			ret
GoodTextureFormat:	mov	eax, [esi + TGA._Width]
			mov	ecx, [esi + TGA.Height]
			mov	[esi + TGA.Orig_Width], eax
			mov	[esi + TGA.Orig_Height], ecx
			; Fix the sizes
			.if	eax > ecx
				mov	[esi + TGA.Height], eax
			.endif
			.if	eax < ecx
				mov	[esi + TGA._Width], ecx
			.endif
			imul	eax, ecx
			push	eax
			mov	eax, [esi + TGA._Width]
			imul	eax, [esi + TGA.Height]
			shl	eax, 2
			mov	eax, ALLOCMEM(eax)
			pop	ecx
			test	eax, eax
			jz	Err_TGA_Format
			mov	[esi + TGA.Datas], eax
			mov	edi, eax

			movzx	eax, byte ptr [ebx]			; Get the length of the image ID field
			.if	[esi + TGA.Bits] == 32
				lea	esi, [ebx + 18 + eax]		; 32 bits image datas
Copy_32Bits:			lodsb
				ror	eax, 8
				lodsb
				ror	eax, 8
				lodsb
				ror	eax, 8 
				lodsb
				bswap	eax
				and	eax, 000ffffffh
				mov	edx, Color_Key
				test	edx,edx
				js	_No_Set_Alpha_32
				and	edx, 000ffffffh
				cmp	edx, eax
				jne	_No_Set_Alpha_32
				mov	eax, 0ff000000h			; Turn alpha channel on for this color
_No_Set_Alpha_32:		xor	eax, 0ff000000h
				stosd
				loop	Copy_32Bits
			.else
				lea	esi, [ebx + 18 + eax]		; 24 bits image datas
Copy_24Bits:			or	eax, -1
				lodsb
				shl	eax, 8
				lodsb
				shl	eax, 8
				lodsb
				and	eax, 000ffffffh
				mov	edx, Color_Key
				test	edx,edx
				js	_No_Set_Alpha_24
				and	edx, 000ffffffh
				cmp	edx, eax
				jne	_No_Set_Alpha_24
				mov	eax, 0ff000000h			; Turn alpha channel on for this color
_No_Set_Alpha_24:		xor	eax, 0ff000000h
				stosd
				loop	Copy_24Bits
			.endif
			FREEMEM	TGA_Buffer
			mov	eax, TRUE				; Loaded
			ret
Load_TGA		endp

; ------------------------------------------------------
; Name: Unload_TGA
; Desc: Free an allocated TARGA picture
Unload_TGA		proc	uses esi TGA_Struct:dword
			mov	esi, TGA_Struct
			test	esi, esi
			jz	@F
			mov	eax, [esi + TGA.Datas]
			test	eax, eax
			jz	@F
			FREEMEM	eax
@@:			ret
Unload_TGA		endp
